##############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : Dr. Detlef Groth
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <031023.1253>
#
#  Description	 
#
#  Notes
#
#  History
#	
#  $Log$
#
##############################################################################
#
#  Copyright (c) 2003 MPIMG Berlin, Germany.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################

package provide app-dgPipPoster 1.0
package require Tk
package require Tix
package require iniparse
set dir [file dirname [info script]] 
source [file join $dir iniload.tcl]
global var
global gui
global data
global img
global mnu
global styles
set var(ini) {RECENT}
set var(version) 1.0
proc main {} {
    global gui var data mnu tcl_platform
    set var(appname) [file rootname [file tail [info script]]]
    set dir [file dirname [info script]]
    if {[file rootname [file tail [info nameofexe]]] ne $var(appname)} {
        catch {wm iconbitmap . -default "[file join $dir .. .. tclkit.ico]"}
    }
    wm title . "$var(appname) $var(version)"
    menu .menubar
    . config -menu .menubar
   
    set mnu(file) [menu .menubar.file -tearoff 0]
    set mnu(help) [menu .menubar.help -tearoff 0]
    .menubar add cascade -label File -underline 0 -menu $mnu(file) 
    .menubar add cascade -label Help -underline 0 -menu $mnu(help) 
    $mnu(help) add command -label "About ... " -underline 0 -command \
             { tk_messageBox -title "About!" -icon info \
              -message "dgPipPoster by Dr. Detlef Groth\n\n     2003\n  dgroth@molgen.mpg.de\n  requires: ImageMagick 5.5.* and Ghostscript 7.*" -type ok}
    
  
  
    $mnu(file) add separator
    set mnu(file-recent) [menu .menubar.file.recent -tearoff 0]
    .menubar.file add cascade -label "Recent Files ..." -underline 0 -menu $mnu(file-recent) 
    .menubar.file add command -label "Open File ..." -underline 0 -command on_file_open
    ini_load RECENTS 10 LASTFILE 1 CONVERTEXE 1
    ini_mnu_install $mnu(file-recent) RECENTS file_load 9
    #adjust the proper commands
    ini_mnu_update  $mnu(file-recent) RECENTS file_load 9
    $mnu(file) add separator
    $mnu(file) add command -label Exit -underline 1 -command  {destroy .}
    pack [frame .top] -side top -fill x -expand yes
    pack [label .top.lblext -text "extension: "] -side left
    pack [spinbox .top.ext -values {png tiff jpeg bmp}]  -side left -fill x -expand no
    pack [tixComboBox .top.max -label maxval: -editable true]  -side left -fill x -expand no
    .top.max insert end 3
    .top.max insert end 5
    .top.max insert end 7
    .top.max pick 0
    pack [label .top.lblkb -text "kb: "] -side left
    pack [spinbox .top.kb -width 8 -from 20 -to 2000 -increment 20]  -side left -fill x -expand no
    pack [tixComboBox .top.qual -label dpi: -editable false -listwidth 30]  -side left -expand no
    .top.qual insert end 72
    .top.qual insert end 144
    .top.qual insert end 288
    .top.qual pick 0
    pack [tixComboBox .top.rotate -label rotate: -editable false -width 30]  -side left  -expand no
    .top.rotate insert end no
    .top.rotate insert end yes
    .top.rotate pick 0
    pack [button .top.exec -text convert -command {run} -state disabled] -side left -padx 5
    
  
    
    pack [tixMeter .tm -text progress]  -expand no -padx 2 -pady 5
    if { [ini_option_get CONVERTEXE] eq 0 || [ini_option_get CONVERTEXE] eq ""} {
        set conv [auto_execok convert]
        switch -exact -- [lindex $tcl_platform(os) 0]  {
            Windows {
                set types {
                    {{Exe Files}       {.exe}        }
                    {{All Files}        *             }
                }
                set filename [tk_getOpenFile -filetypes $types -title "Select ImageMagics convert.exe !"]
                if {$filename != ""} {
                    ini_option_set CONVERTEXE $filename
                    set var(convert) $filename
                } 
            }
            Linux {
                if {$conv ne ""}  {
                    ini_option_set CONVERTEXE $conv
                    set var(convert) $conv
                } else {
                    tk_messageBox -title "Info!" -icon info -message "Sorry! ImageMagics convert not found. Please install ImageMagic! see:http://www.imagemagick.org/!" -type ok
                    exit
                }
            }
            OSF1 {
                if {$conv ne ""}  {
                    ini_option_set CONVERTEXE $conv
                    set var(convert) $conv
                } else {
                    tk_messageBox -title "Info!" -icon info -message "Sorry! ImageMagics convert not found. Please install ImageMagic! see:http://www.imagemagick.org/!" -type ok
                    exit
                }
            }
            default {
                tk_messageBox -title "Info!" -icon info -message "Sorry! Platform $tcl_platform(platform) still not supported!" -type ok
                exit
            }
        }
    } else {
        set var(convert) [ini_option_get CONVERTEXE]
    }
}
proc on_file_open { } {
    global var
    set types {
        {{PDF Files}       {.pdf}        }
        {{Postscript Files}       {.ps}  }
        {{All Files}        *             }
    }
    set filename [tk_getOpenFile -filetypes $types]
    if {$filename != ""} {
        file_load $filename
    }
}
proc file_load { filename } {
    global var mnu env
    .top.exec configure -state normal
    wm title . "$var(appname) $var(version) - [file tail $filename]"
  
    set var(processfile) [file tail $filename]
    set var(resultdir) [file dirname $filename]
    if { ![file exists [file join $env(HOME) temp]] } {
        file mkdir [file join $env(HOME) temp]
    }
   
    ini_unshift RECENTS $filename 9
    ini_mnu_update  $mnu(file-recent) RECENTS file_load 9
}
proc run {} {
    global var env
    set res [.top.qual subwidget entry get]
    set qual [expr $res/72]
    file copy -force [ini_get RECENTS 1] [file join $env(HOME) temp $var(processfile)]
    set ext [.top.ext get]
    cd [file join $env(HOME) temp]
    #file copy -force $var(resultdir)/$var(processfile) $var(processfile)
    set max [.top.max subwidget entry get]
    set kb [.top.kb get]
    set n 0
    set rownr 0
    set oldpage 0
    #set geo 519x112+40+24
    set row -1
    for {set i 0} {$i <= $kb} {incr i 20} {
        set page [expr $i/120+1]
        incr n
        incr row
        if { $row % 6 == 0 } {
            set row 0
        }
        set pady [expr (113*$row+24)*$qual]
        set padx [expr 92*$qual]
        set height [expr 115*$qual]
   
        if { $n == $max } {
            set width [expr 520*$qual]
           
        } elseif { $n == 1 } {
            set padx [expr 40*$qual]
            set height [expr 112*$qual]
            set width [expr 520*$qual]
            
        }  else {
            set width [expr 468*$qual]
        }
        set oldpage $page
        
        .tm configure -value $i/$kb -text "done: $i / $kb kb"
        update idletasks
        lappend size $width $height
        set crop "[join $size x]+$padx+$pady"
        puts "convert -crop $crop \"$var(processfile)\[$page\]\" sample$n.$ext"
        if { [.top.rotate subwidget entry get] eq yes} {
             exec $var(convert) -density $res -rotate -90 -crop $crop "$var(processfile)\[$page\]" sample$n.$ext
        } else {
            exec $var(convert) -density $res -crop $crop "$var(processfile)\[$page\]" sample$n.$ext
        }
        set size {}
        lappend rowconv  "sample$n.$ext"
        if { $n == $max } {
            set n 0
            set files "[join $rowconv]"
            
            set cmd [subst {$var(convert) +append $files combined$rownr.$ext}]
           
            # use -append for topdown
            puts "Combining row ..."
            puts $cmd
            eval exec $cmd
            foreach file $rowconv {
                #file delete -force $file
            }
            set rowconv {}
            lappend multirows combined$rownr.$ext
            incr rownr
           
        } 
      
       
    }
 
    if [info exists multirows] {
        if { [llength $multirows] > 1 } {
            set files "[join $multirows]"
            
            set cmd [subst {$var(convert) -append $files result.$ext}]
        
            # use -append for topdown
            puts "Combining all ..."
            puts $cmd
            eval exec $cmd
            foreach file $multirows {
                file delete $file
            }
        } else {
            file copy [lindex $multirows 0] result.$ext
            file delete [lindex $multirows 0] 
        }
        file copy -force result.$ext [file join $var(resultdir) result.$ext]
        file delete result.$ext
        file delete sample1.$ext
        file delete sample2.$ext
        file delete $var(processfile)
    }
    .tm configure -value 1
    .tm configure -text done
    tk_messageBox -title "Info!" -icon info -message "Conversion done! Result is in\n [file join $var(resultdir) result.$ext]!" -type ok
    return
  
   
}
main
#Assume your three images are called image1.ppm, image2.ppm, and image3.ppm. Type 
#
#convert +append image1.ppm image2.ppm \
#          image3.ppm side_by_side.miff
#
#To concatenate the images top-to-bottom, use -append. 
#For more control over the placement of an image, use composite. First create a matte image and position your images onto the matte. For example,
#
# convert -size 350x500 xc:black composite.miff
# composite -geometry +0+0 composite.miff image1.gif composite.miff
# composite -geometry +100+0 composite.miff image2.gif composite.miff
# composite -geometry +0+300 composite.miff image3.gif composite.miff
# composite -geometry +0+375 composite.miff image4.gif composite.miff
